%global debug_package %{nil}

Summary:        Exporter for machine metrics
Name:           node_exporter
Version:        1.5.0
Release:        3%{?dist}
License:        ASL 2.0
URL:            https://github.com/prometheus/node_exporter
Source0:        https://github.com/prometheus/node_exporter/archive/v%{version}.tar.gz
# cd %%{name}-%%{version}
# go mod vendor
# tar -zcf vendor.tar.gz vendor/
Source1:        vendor.tar.gz
Source2:        sysconfig.node_exporter
Source3:        node_exporter.service
Source4:        node_exporter_textfile_wrapper.sh
Source5:        textfile_collectors_README

BuildRequires:  systemd promu golang
Requires:       shadow coreutils
Provides:       node_exporter = %{version}-%{release}

ExclusiveArch:  x86_64 aarch64 riscv64

%description
Exporter for machine metrics.

%package devel
Summary:       Exporter for machine metrics
BuildRequires: git golang
BuildArch:     noarch

%description devel
Exporter for machine metrics. This package contains library source
intended for building other packages which use import path with
github.com/prometheus/node_exporter prefix.


%prep
%autosetup -a1 -n %{name}-%{version} -p1


%build
export GOFLAGS="-mod=vendor"
promu build


%install
install -d -p   %{buildroot}%{_sbindir} \
                %{buildroot}%{_defaultdocdir}/node_exporter \
                %{buildroot}%{_sysconfdir}/sysconfig \
                %{buildroot}%{_sysconfdir}/prometheus/node_exporter/text_collectors \
                %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/node_exporter
install -p -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/node_exporter.service
install -p -m 0755 %{SOURCE4} %{buildroot}%{_sbindir}/node_exporter_textfile_wrapper
install -p -m 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/prometheus/node_exporter/text_collectors/README

install -d -p %{buildroot}/%{_datadir}/gocode/src/github.com/prometheus/node_exporter/
echo "%%dir %{_datadir}/gocode/src/github.com/prometheus/node_exporter/." >> devel.file-list
for file in $(find . \( -iname "*.go" -or -iname "*.s" \) \! -iname "*_test.go" | grep -v "vendor") ; do
    dirprefix=$(dirname $file)
    install -d -p %{buildroot}/%{_datadir}/gocode/src/github.com/prometheus/node_exporter/$dirprefix
    cp -pav $file %{buildroot}/%{_datadir}/gocode/src/github.com/prometheus/node_exporter/$file
    echo "%%{_datadir}/gocode/src/github.com/prometheus/node_exporter/$file" >> devel.file-list
    while [ "$dirprefix" != "." ]; do
        echo "%%dir %{_datadir}/gocode/src/github.com/prometheus/node_exporter/$dirprefix" >> devel.file-list
        dirprefix=$(dirname $dirprefix)
    done
done

sort -u -o devel.file-list devel.file-list


%files
%license LICENSE
%doc *.md text_collector_examples
%config(noreplace) %{_sysconfdir}/sysconfig/node_exporter
%config %{_sysconfdir}/prometheus/node_exporter/text_collectors/README
%{_sbindir}/*
%{_unitdir}/node_exporter.service

%files devel -f devel.file-list
%dir %{_datadir}/gocode/src/github.com/prometheus

%pre
getent group node_exporter > /dev/null || groupadd -r node_exporter
getent passwd node_exporter > /dev/null || \
    useradd -rg node_exporter -d /var/lib/node_exporter -s /sbin/nologin \
            -c "Prometheus node exporter" node_exporter
mkdir -p /var/lib/node_exporter/textfile_collector
chgrp node_exporter /var/lib/node_exporter/textfile_collector
chmod 771 /var/lib/node_exporter/textfile_collector

%post
%systemd_post node_exporter.service

%preun
%systemd_preun node_exporter.service

%postun
%systemd_postun node_exporter.service

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 12 2023 Miaojun Dong <zoedong@tencent.com> - 1.5.0-1
- initial build
